#include <rose.h>
#include <Outliner.hh>
#include <iostream>
#include <string>
#include <xevxml.hpp>
#include "mypragma.h"

using namespace std;
using namespace SageInterface;
using namespace SageBuilder;
using namespace AstFromString;
//pragma declaration
bool afs_match_outline (SgExpression **num ){
	bool result = false;

	if (!afs_match_expression()){
		printf ("Error:hoge \n");
		assert (false);
	}
	assert (c_parsed_node != NULL);
	assert (isSgExpression(c_parsed_node) != NULL);
	*num = isSgExpression(c_parsed_node);

	return result;
}

class  OutlineXev :public AstSimpleProcessing
{
	SgGlobal* global;
public:
	std::vector<string> funcCall;
	std::vector<Outliner::Result> results;
	std::vector<string> fnames;
	std::string fname;
	std::vector<int>dupi;
	std::vector<int>::iterator begin,end;
	 int dup ;

	OutlineXev():global(NULL){}
	void visit(SgNode* n);
	void replaceCalls();
	AstAttribute* parse_MY_Pragma(SgNode* n);
	AstAttribute* parse_MY_Pragma_1(SgNode* n);
};
	void OutlineXev::visit(SgNode* n){
		 parse_MY_Pragma (isSgNode(n));
		 parse_MY_Pragma_1(isSgNode(n));
   }

AstAttribute* OutlineXev::parse_MY_Pragma(SgNode* n){
	AstAttribute*  result = NULL;
	SgLocatedNode* locatedNode = isSgLocatedNode(n);
	if (locatedNode != NULL){
		AttachedPreprocessingInfoType* comments = locatedNode->getAttachedPreprocessingInfo();
		if (comments != NULL){
			AttachedPreprocessingInfoType::iterator i;
			const char* old_char = c_char;
			SgNode* old_node = c_sgnode;
			c_sgnode = locatedNode;
			assert (c_sgnode != NULL);

			for (i = comments->begin(); i != comments->end(); i++){
				c_char = (*i)->getString().c_str();
					if (afs_match_substr("!$xev at")){
						SgExpression* number_exp = isSgExpression(c_parsed_node);
						afs_match_outline (&number_exp);
						result = new MY_PragmaAttribute (c_sgnode, pragma_xev_at_num, number_exp ) ;
						assert (result != NULL);
						std::stringstream  ss(result->toString());
						ss>>dup;
						dupi.push_back(dup);
						SgStatement* gns =isSgStatement(c_sgnode);
						std::vector<SgStatement*> copy;
						copy.push_back(gns);

							for(int i(1);i<dup;i++){
								copy.push_back(isSgStatement(SageInterface::deepCopyNode(gns)));
								SageInterface::insertStatementAfter(copy[i-1],copy[i]);
							}

							for(int i(0);i<dup;i++){
								results.push_back(Outliner::outline(copy[i]));
							}
					}
			}
			c_char = old_char;
			c_sgnode = old_node;
		}
	}
	return 0;

}

AstAttribute* OutlineXev::parse_MY_Pragma_1(SgNode* n){
	SgLocatedNode* locatedNode = isSgLocatedNode(n);
	 if (locatedNode != NULL){
		 AttachedPreprocessingInfoType* comments = locatedNode->getAttachedPreprocessingInfo();

	        if (comments != NULL){
	               AttachedPreprocessingInfoType::iterator i;
	               const char* old_char = c_char;
	               SgNode* old_node = c_sgnode;
	               c_sgnode = locatedNode;
	               assert (c_sgnode != NULL);

	               for (i = comments->begin(); i != comments->end(); i++){
				   c_char = (*i)->getString().c_str();

				   if  (afs_match_substr("!$xev at")){
					   if (afs_match_expression()){
						   fname =  c_char ;
						   fnames.push_back(fname);
					   }
					   else  {
					  	  cout<<"no func name"<<endl;
					   }
				   }
			//	   else {cout<<"miss"<<endl;}
			   }
	               c_char = old_char;
			 c_sgnode = old_node;
	        }
	 }
		 return 0;
}


void OutlineXev::replaceCalls(){
	int k =0 ;
	for(int j = 0 ; j < dupi.size() ; j ++){
			      /*build outliner1(select,&y,&i);*/
		std::vector<SgExprListExp*>exp;
		Rose_STL_Container<SgNode*> exples= NodeQuery::querySubTree(results[dupi[j]+k-1].call_,V_SgExprListExp);
		Rose_STL_Container<SgNode*>::const_iterator l = exples.begin();

		for(; l!=exples.end();++l){
			SgExprListExp* exple = isSgExprListExp(SageInterface::deepCopyNode(*l));
			exp.push_back(exple);
		}
		SgExprListExp* eplist = SageBuilder::buildExprListExp();
		for(float i(0);i<exp.size();i++){
			eplist->append_expression(exp[i]);
		}

		SgFunctionRefExp* frp = SageBuilder::buildFunctionRefExp("call"+fnames[j],results[0].call_->get_scope());
		SgFunctionCallExp* fce =SageBuilder::buildFunctionCallExp(frp,eplist);
		SgExprStatement* exprstmt=SageBuilder::buildExprStatement(fce);
		SageInterface::insertStatementAfter(results[dupi[j]+k-1].call_,exprstmt);

		/*insert pragma問題点２*/
		for(int i =0 ; i<dupi[j];i++){
			stringstream ss;
			int s = i + 1;
			ss << s;
			std::string pname ="$xev"+fnames[j] + "_loop_tag_" + ss.str();
			Rose_STL_Container<SgNode*> fordo = NodeQuery::querySubTree(results[i+k].decl_,V_SgFortranDo);
			Rose_STL_Container<SgNode*>::const_iterator l =fordo.begin();
			for(; l!=fordo.begin()+ 1;++l){
				SgLocatedNode* locatedNode = isSgLocatedNode(*l);
				SageInterface::attachComment(locatedNode,pname);
			}
		}
		k +=dupi[j];
	}

	for(float i(0);i<results.size();i++)
		  SageInterface::removeStatement(results[i].call_);
}

int main(int argc, char * argv[]){
//	  vector<string> argvList(argv,argv+argc);
//
//	  SgProject* proj = frontend (argvList);
	  // Build the AST used by ROSE
		  int             fd=0;
		  SgProject*      sageProject=0;
		  vector<string> args;

		  for(int id(0);id<argc;++id)
		    args.push_back( string(argv[id]) );
		  args.push_back( string("-rose:skip_syntax_check")); // some Fortran codes need this

		  fd = dup(fileno(stdout));
		  dup2(fileno(stderr),fileno(stdout)); // printf messages are written to stderr
		  sageProject = frontend(args); // build an ROSE AST from a code
		  bool r = false;

	//  ROSE_ASSERT (proj);

	  XevXml::XevInitialize();

	// Outline
	  OutlineXev outlining;

	  outlining.traverseInputFiles(sageProject,preorder);

	  outlining.replaceCalls();
	  //file の書き込み方法不明
	  FILE* fp_out = freopen("out-triple-1.f90", "w", stdout);

	  XevXml::XevUnparseToStream(cout,&sageProject);
	 	 fclose(fp_out);
	  /* visit every node and write it as an XML element */
#if  0
	  XevXml::XevSageVisitor sagevisitor;
	    sagevisitor.setXmlOption(new XevXml::XevXmlOption());
		  XevXml::XevXmlOption opt;
		  fflush(stdout);
		  dup2(fd,1); // printf messages are written to stdout

	    sagevisitor.write(cout,&sageProject);
//	     generatePDF ( *sageProject );

	    XevXml::XevFinalize();
	    return 0;
#endif
	//    XevXml::XevFinalize();

//	    return r?0:(-1);

//	    return backend(r);
	    return 0;
}
